gi-gobject-2.0.31: GObject bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GObject.Objects.TypeModule

Contents

- Exported types
- Methods
  - addInterface
  - registerEnum
  - registerFlags
  - registerType
  - setName
  - unuse
  - use

Description

`GTypeModule` provides a simple implementation of the `GTypePlugin` interface.

The model of `GTypeModule` is a dynamically loaded module which implements some number of types and interface implementations.

When the module is loaded, it registers its types and interfaces using `typeModuleRegisterType` and `typeModuleAddInterface`. As long as any instances of these types and interface implementations are in use, the module is kept loaded. When the types and interfaces are gone, the module may be unloaded. If the types and interfaces become used again, the module will be reloaded. Note that the last reference cannot be released from within the module code, since that would lead to the caller's code being unloaded before `g_object_unref()` returns to it.

Keeping track of whether the module should be loaded or not is done by using a use count - it starts at zero, and whenever it is greater than zero, the module is loaded. The use count is maintained internally by the type system, but also can be explicitly controlled by `typeModuleUse` and `typeModuleUnuse`. Typically, when loading a module for the first type, `g_type_module_use()` will be used to load it so that it can initialize its types. At some later point, when the module no longer needs to be loaded except for the type implementations it contains, `g_type_module_unuse()` is called.

`GTypeModule` does not actually provide any implementation of module loading and unloading. To create a particular module type you must derive from `GTypeModule` and implement the load and unload functions in `GTypeModuleClass`.

Synopsis

- newtype TypeModule = TypeModule (ManagedPtr TypeModule)
- class (GObject o, IsDescendantOf TypeModule o) => IsTypeModule o
- toTypeModule :: (MonadIO m, IsTypeModule o) => o -> m TypeModule
- typeModuleAddInterface :: (HasCallStack, MonadIO m, IsTypeModule a) => Maybe a -> GType -> GType -> InterfaceInfo -> m ()
- typeModuleRegisterEnum :: (HasCallStack, MonadIO m, IsTypeModule a) => Maybe a -> Text -> [EnumValue] -> m GType
- typeModuleRegisterFlags :: (HasCallStack, MonadIO m, IsTypeModule a) => Maybe a -> Text -> [FlagsValue] -> m GType
- typeModuleRegisterType :: (HasCallStack, MonadIO m, IsTypeModule a) => Maybe a -> GType -> Text -> TypeInfo -> [TypeFlags] -> m GType
- typeModuleSetName :: (HasCallStack, MonadIO m, IsTypeModule a) => a -> Text -> m ()
- typeModuleUnuse :: (HasCallStack, MonadIO m, IsTypeModule a) => a -> m ()
- typeModuleUse :: (HasCallStack, MonadIO m, IsTypeModule a) => a -> m Bool

# Exported types

newtype TypeModule Source #

Memory-managed wrapper type.

Constructors

TypeModule (ManagedPtr TypeModule) |

#### Instances

Instances details

Eq TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule Methods (==) :: TypeModule -> TypeModule -> Bool Source # (/=) :: TypeModule -> TypeModule -> Bool Source #
GObject TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule
ManagedPtrNewtype TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule Methods toManagedPtr :: TypeModule -> ManagedPtr TypeModule Source #
TypedObject TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule Methods glibType :: IO GType Source #
HasParentTypes TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule
IsGValue (Maybe TypeModule) Source # | Convert `TypeModule` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GObject.Objects.TypeModule Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TypeModule -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TypeModule) Source #
type ParentTypes TypeModule Source # |
Instance details Defined in GI.GObject.Objects.TypeModule type ParentTypes TypeModule = '[Object, TypePlugin]

class (GObject o, IsDescendantOf TypeModule o) => IsTypeModule o Source #

Type class for types which can be safely cast to `TypeModule`, for instance with `toTypeModule`.

#### Instances

Instances details

(GObject o, IsDescendantOf TypeModule o) => IsTypeModule o Source # |
Instance details Defined in GI.GObject.Objects.TypeModule

toTypeModule :: (MonadIO m, IsTypeModule o) => o -> m TypeModule Source #

Cast to `TypeModule`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addInterface, bindProperty, bindPropertyFull, completeInterfaceInfo, completeTypeInfo, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, registerEnum, registerFlags, registerType, runDispose, stealData, stealQdata, thawNotify, unref, unuse, use, watchClosure.

#### Getters

getData, getProperty, getQdata.

#### Setters

setData, setDataFull, setName, setProperty.

## addInterface

typeModuleAddInterface Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> Maybe a | `module`: a `TypeModule`
-> GType | `instanceType`: type to which to add the interface.
-> GType | `interfaceType`: interface type to add
-> InterfaceInfo | `interfaceInfo`: type information structure
-> m () |

Registers an additional interface for a type, whose interface lives in the given type plugin. If the interface was already registered for the type in this plugin, nothing will be done.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `Nothing` this will call `typeAddInterfaceStatic` instead. This can be used when making a static build of the module.

## registerEnum

typeModuleRegisterEnum Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> Maybe a | `module`: a `TypeModule`
-> Text | `name`: name for the type
-> [EnumValue] | `constStaticValues`: an array of `EnumValue` structs for the possible enumeration values. The array is terminated by a struct with all members being 0.
-> m GType | Returns: the new or existing type ID

Looks up or registers an enumeration that is implemented with a particular type plugin. If a type with name `typeName` was previously registered, the `GType` identifier for the type is returned, otherwise the type is newly registered, and the resulting `GType` identifier returned.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `Nothing` this will call `typeRegisterStatic` instead. This can be used when making a static build of the module.

Since: 2.6

## registerFlags

typeModuleRegisterFlags Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> Maybe a | `module`: a `TypeModule`
-> Text | `name`: name for the type
-> [FlagsValue] | `constStaticValues`: an array of `FlagsValue` structs for the possible flags values. The array is terminated by a struct with all members being 0.
-> m GType | Returns: the new or existing type ID

Looks up or registers a flags type that is implemented with a particular type plugin. If a type with name `typeName` was previously registered, the `GType` identifier for the type is returned, otherwise the type is newly registered, and the resulting `GType` identifier returned.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `Nothing` this will call `typeRegisterStatic` instead. This can be used when making a static build of the module.

Since: 2.6

## registerType

typeModuleRegisterType Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> Maybe a | `module`: a `TypeModule`
-> GType | `parentType`: the type for the parent class
-> Text | `typeName`: name for the type
-> TypeInfo | `typeInfo`: type information structure
-> [TypeFlags] | `flags`: flags field providing details about the type
-> m GType | Returns: the new or existing type ID

Looks up or registers a type that is implemented with a particular type plugin. If a type with name `typeName` was previously registered, the `GType` identifier for the type is returned, otherwise the type is newly registered, and the resulting `GType` identifier returned.

When reregistering a type (typically because a module is unloaded then reloaded, and reinitialized), `module` and `parentType` must be the same as they were previously.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `Nothing` this will call `typeRegisterStatic` instead. This can be used when making a static build of the module.

## setName

typeModuleSetName Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> a | `module`: a `TypeModule`.
-> Text | `name`: a human-readable name to use in error messages.
-> m () |

Sets the name for a `TypeModule`

## unuse

typeModuleUnuse Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> a | `module`: a `TypeModule`
-> m () |

Decreases the use count of a `TypeModule` by one. If the result is zero, the module will be unloaded. (However, the `TypeModule` will not be freed, and types associated with the `TypeModule` are not unregistered. Once a `TypeModule` is initialized, it must exist forever.)

## use

typeModuleUse Source #

Arguments

:: (HasCallStack, MonadIO m, IsTypeModule a) |
=> a | `module`: a `TypeModule`
-> m Bool | Returns: `False` if the plugin needed to be loaded and loading the plugin failed.

Increases the use count of a `TypeModule` by one. If the use count was zero before, the plugin will be loaded. If loading the plugin fails, the use count is reset to its prior value.